#include "parser.hpp"

#define YYSTYPE void*
#include "parser.tab.hpp"

extern void yyparse();

namespace parser {
	bool success;
	std::list<function>* program;
	int (*get_char)(int* p);
	bool yyparse(std::list<function>* out)
	{ program=out; success=true; ::yyparse(); return success; }
}

int yyerror(char const* ch)
{
	parser::success=false;
	return 1;
}

int yylex()
{
    int i=0;
	int const c=parser::get_char(&i);

	if(c==256){
	    yylval=(void*)i;
	    return NUMBER;
	}

	if(std::isdigit(c)) {
		yylval=(void*)(c-'0');
		return NUMBER;
	}

	if(c=='s' || c=='l' || c=='r') return c;

	yylval=(void*)((int)c);

	if(std::islower(c)) return FUNC_NAME;

	if(std::isupper(c)) return ARG;
	return c;
}
